program fp_inquiry

  implicit none

  integer,parameter :: r1=selected_real_kind(5,10)    ! single precision
  integer,parameter :: r2=selected_real_kind(10,40)   ! double precision
  integer,parameter :: r3=selected_real_kind(30,200)  ! quadruple precision

  real(r1) :: x1,s1
  real(r2) :: x2,s2
  real(r3) :: x3,s3
  integer :: i,s
  character(len=80) :: fmi,fmr,fmr1
  integer :: command_argument_count

  x1=1.0_r1
  x2=1.0_r2
  x3=1.0_r3
  i=4
  s1=1.0_r1
  s2=1.0_r2
  s3=1.0_r3  

  if (command_argument_count()==1) then
     call get_command_argument(1,fmi)
     read(fmi,*) i
  end if

  fmi='(a16,i30)'
  fmr='(a16,g30.10)'
  fmr1='(a16,x,g0)'

  
  write(6,'(/,50("="),/)') 
  write(6,fmi) 'digits',       digits(x1)         ! number of significant digits
  write(6,fmr) 'epsilon',      epsilon(x1)        ! least  positive  number  that added to 1 returns a number that is greater than 1
  write(6,fmr) 'huge',         huge(x1)           ! largest positive number
  write(6,fmi) 'maxexpponent', maxexponent(x1)    ! largest exponent
  write(6,fmi) 'minexponent',  minexponent(x1)    ! smallest exponent
  write(6,fmi) 'precision',    precision(x1)      ! decimal precision
  write(6,fmi) 'radix',        radix(x1)          ! base in the model
  write(6,fmi) 'range',        range(x1)          ! decimal exponent
  write(6,fmr) 'tiny',         tiny(x1)           ! smallest positive number
  write(6,*) 
  write(6,fmi) 'exponent',     exponent(x1)       ! exponent of the number
  write(6,fmr) 'nerarest',     nearest(x1,s1)     ! returns the next representable number in the direction of the sign of s
  write(6,fmr) 'rrspacing',    rrspacing(x1)      ! returns the inverted value of the distance between the two nearest possible numbers
  write(6,fmr) 'scale',        scale(x1,i)        ! multiplies x by the base to the power i
  write(6,fmr) 'set_exponent', set_exponent(x1,i) ! returns the number that has the fractional part of x and the exponent i
  write(6,fmr) 'spacing',      spacing(x1)        ! the distance between the two nearest possible numbers 
  write(6,fmr) 'fraction',     fraction(x1)       ! the fractional part of the number


  write(6,'(/,50("="),/)') 
  write(6,fmi) 'digits',       digits(x2)         ! number of significant digits
  write(6,fmr) 'epsilon',      epsilon(x2)        ! least  positive  number  that added to 1 returns a number that is greater than 1
  write(6,fmr) 'huge',         huge(x2)           ! largest positive number
  write(6,fmi) 'maxexpponent', maxexponent(x2)    ! largest exponent
  write(6,fmi) 'minexponent',  minexponent(x2)    ! smallest exponent
  write(6,fmi) 'precision',    precision(x2)      ! decimal precision
  write(6,fmi) 'radix',        radix(x2)          ! base in the model
  write(6,fmi) 'range',        range(x2)          ! decimal exponent
  write(6,fmr) 'tiny',         tiny(x2)           ! smallest positive number
  write(6,*) 
  write(6,fmi) 'exponent',     exponent(x2)       ! exponent of the number
  write(6,fmr) 'nerarest',     nearest(x2,s2)     ! returns the next representable number in the direction of the sign of s
  write(6,fmr) 'rrspacing',    rrspacing(x2)      ! returns the inverted value of the distance between the two nearest possible numbers
  write(6,fmr) 'scale',        scale(x2,i)        ! multiplies x by the base to the power i
  write(6,fmr) 'set_exponent', set_exponent(x2,i) ! returns the number that has the fractional part of x and the exponent i
  write(6,fmr) 'spacing',      spacing(x2)        ! the distance between the two nearest possible numbers 
  write(6,fmr) 'fraction',     fraction(x2)       ! the fractional part of the number

  write(6,'(/,50("="),/)') 
  write(6,fmi) 'digits',       digits(x3)         ! number of significant digits
  write(6,fmr) 'epsilon',      epsilon(x3)        ! least  positive  number  that added to 1 returns a number that is greater than 1
  write(6,fmr1) 'huge',         huge(x3)           ! largest positive number
  write(6,fmi) 'maxexpponent', maxexponent(x3)    ! largest exponent
  write(6,fmi) 'minexponent',  minexponent(x3)    ! smallest exponent
  write(6,fmi) 'precision',    precision(x3)      ! decimal precision
  write(6,fmi) 'radix',        radix(x3)          ! base in the model
  write(6,fmi) 'range',        range(x3)          ! decimal exponent
  write(6,fmr1) 'tiny',         tiny(x3)           ! smallest positive number
  write(6,*) 
  write(6,fmi) 'exponent',     exponent(x3)       ! exponent of the number
  write(6,fmr) 'nerarest',     nearest(x3,s2)     ! returns the next representable number in the direction of the sign of s
  write(6,fmr) 'rrspacing',    rrspacing(x3)      ! returns the inverted value of the distance between the two nearest possible numbers
  write(6,fmr) 'scale',        scale(x3,i)        ! multiplies x by the base to the power i
  write(6,fmr) 'set_exponent', set_exponent(x3,i) ! returns the number that has the fractional part of x and the exponent i
  write(6,fmr) 'spacing',      spacing(x3)        ! the distance between the two nearest possible numbers 
  write(6,fmr) 'fraction',     fraction(x3)       ! the fractional part of the number

  write(6,'(/,50("="),/)') 

  stop
end program fp_inquiry
