program realdoubletest
  
  implicit none
  integer, parameter :: N=_N_
  
  !R1 integer,parameter :: R=selected_real_kind(5,10)    ! single precision
  !R2 integer,parameter :: R=selected_real_kind(10,40)   ! double precision
  !R3 integer,parameter :: R=selected_real_kind(30,200)  ! quadruple precision

  real(kind=R),parameter:: dx=0.0001_R
  real(kind=R) :: x,y,z
  real :: t1,t2,t3
  integer :: i
  x=dx; y=0.0; z=0.0

  !write(6,'(a,2i4)') 'RK, digits: ',R,digits(x)
  open(10,file='unform_tmp.dat',form='unformatted')
  call cpu_time(t1)
  do i=1,N
     x=x+dx
     y=y+sin(x)
     z=z+log(x)*cos(x)
  enddo
  call cpu_time(t2)
  write(6,'(g20.10,5x,3g20.10)') t2-t3,x,y,z
  write(10) x
  stop
end program realdoubletest


!--------------------------------------
!
! Results 18.1.2007
! 
! rock
! N=10000000
! 
!         t2-t1         t3-t2
! 16      32.35733      9.7274780E-04
!  8       1.734352     9.7596645E-04
!  4       1.370304     9.7596645E-04
!
!--------------------------------------
